// AffineTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <iostream>
#include <vector>

#include <GL/glut.h>
#include "Eigen/Core"
#include "Eigen/SVD"
#include "Eigen/LU"

using namespace std;
using namespace Eigen;

double windowWidth = 640.0;
double windowHeight = 480.0;
double aspect = 640.0/480.0;
double fovy = 60.0;
double zNear = 1.0;
double zFar = 10.0;
double eyePos[3] = {5.0, 4.0, 5.0};
double eyeTarget[3] = {0, 0, 0};
double eyeUp[3] = {0, 1, 0};
double theta = 0;
double mouseX, mouseY;

MatrixXd projMat, projInv, modelMat, modelInv;
VectorXd clickPos;

// fr[s̋tsvZ
void calculateModelInv(GLfloat *mat)
{
    for (int i=0; i<4; i++)
    {
        for (int j=0; j<4; j++)
        {
            modelMat(i, j) = mat[j*4+i];
        }
    }
    modelInv = modelMat.inverse();
}

// vWFNVs̋tsvZ
void calculateProjectionInv(GLfloat *mat)
{
    for (int i=0; i<4; i++)
    {
        for (int j=0; j<4; j++)
        {
            projMat(i, j) = mat[j*4+i];
        }
    }
    projInv = projMat.inverse();
}

void display(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    // view
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    // _̐ݒ
    GLfloat temp[3];
    temp[0] = eyePos[0]*sin(theta);
    temp[1] = eyePos[1];
    temp[2] = eyePos[2]*cos(theta);
    gluLookAt(temp[0], temp[1], temp[2], 
        eyeTarget[0], eyeTarget[1], eyeTarget[2],
        eyeUp[0], eyeUp[1], eyeUp[2]);
    // fr[s̎擾
    GLfloat model[16];
    glGetFloatv(GL_MODELVIEW_MATRIX, model);
    // fr[s̋tsvZ
    calculateModelInv(model);

    // }EXNbNꂽW̃[hWvZ
    clickPos(0) = 2.0*mouseX/windowWidth-1.0;   // -1.01.0͈̔͂ɕϊ
    clickPos(1) = -2.0*mouseY/windowHeight+1.0;  // -1.01.0͈̔͂ɕϊ(y͋t)
    clickPos(2) = -1.0;                         // ߃NbvʂȂ̂-1.0
    clickPos(3) = 1.0;                          // WȂ̂1.0
    clickPos = modelInv*projInv*clickPos;       // tsă[hWvZ

    // _̕\
    glPointSize(10.0);
    glBegin(GL_POINTS);
    glColor3f(1,0,0);
    glVertex3d(clickPos(0), clickPos(1), clickPos(2));
    glEnd();

    // ̂̕\
    glColor3f(1,1,1);
    glutSolidCube(3.0);

    theta += 0.01;

//    printf("theta=%f\n", theta);
    glutSwapBuffers();
    glFlush();
}

void resize(int w, int h)
{
    // s̏
    projMat = MatrixXd::Zero(4,4);
    projInv = MatrixXd::Zero(4,4);
    modelMat = MatrixXd::Zero(4, 4);
    modelInv = MatrixXd::Zero(4, 4);
    clickPos = VectorXd::Zero(4);

    // EBhE̕ƍi[
	windowWidth = w;
	windowHeight = h;
	// r[|[g̐ݒ
	glViewport(0, 0, (int)windowWidth, (int)windowHeight);
	
    // vWFNV[hւ̕ύX
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    aspect = windowWidth/windowHeight;
	// eŕ\ 
	gluPerspective(fovy, aspect, zNear, zFar);
    // es擾
    GLfloat proj[16];
    glGetFloatv(GL_PROJECTION_MATRIX, proj);
    // es̋tsvZ
    calculateProjectionInv(proj);

	// fr[[hɖ߂
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void motion(int x, int y)
{
    mouseX = x;
    mouseY = y;
}

void idle()
{
	glutPostRedisplay();
}

void init(void)
{
    glClearColor(0.0, 0.0, 1.0, 1.0);
	glEnable(GL_DEPTH_TEST);
    glEnable(GL_CULL_FACE);
    glEnable(GL_NORMALIZE);
    glDisable(GL_LIGHTING);
}

int _tmain(int argc, char* argv[])
{
    glutInit(&argc, argv);
    glutInitWindowSize((int)windowWidth, (int)windowHeight);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH | GLUT_MULTISAMPLE | GLUT_STENCIL);
    glutCreateWindow("mouse test");
    glutDisplayFunc(display);
    glutReshapeFunc(resize);
    glutPassiveMotionFunc(motion);
    glutIdleFunc(idle);
    init();
    glutMainLoop();

    return 0;
}

